package Program::TCL;

use strict;
use vars qw/$VERSION @ISA @EXPORT/;

require Exporter;
require AutoLoader;
require Program;
require Program::Statement;

@ISA = qw(Exporter AutoLoader Program);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw(

);
$VERSION = '0.01';

# Preloaded methods go here.

sub new {
    my $that = shift;
    my $class = ref($that) || $that;
    my $self = {
	Program_name => shift,
	First_statement => undef,
	Current_statement => undef,
	Language => 'TCL',
	Text => undef,
        Quote => '"((?:\\\\.|[^"])*)"',
        Comment => '#((?:\\\\.|[^\n])*)\n',
        PreProcessor => undef,
        Other => '\\\\.|\w+',
        BlockBrackets => '{',
        Brackets => '([',
        EndOfStmt => ";\n"
    };
    bless $self, $class;
    return $self;
}

# There are some problems here with using the default parser:
# 1. { ... } is sometimes quoted code, not a block.
# 2. # ... is really only a comment if the current statement is blank.
# 3. [ ... ] can signify a "block" of sorts.

sub stmt_is_subr {
    my ($self, $statement) = @_;
    return $1 if (!ref $statement->get_down) and
	$statement->get_code =~ /^proc (\w+)/;
    return undef;
}

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__

# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

Program::TCL - A TCL program

=head1 SYNOPSIS

Program ...

=head1 DESCRIPTION

Program

=head1 BUGS

The documentation for this module is incomplete.

=head1 AUTHOR

James Yolkowski

=head1 SEE ALSO

perl(1).

=cut
