#!/usr/bin/perl -w

use Program;
use Getopt::Std;
use vars qw/$program/;

$opt_u = '';
getopts('u:');

print <<END_OF_HEADER;
<html>
<head>
<title>Function Descriptions</title>
</head>
<body>
<table border>
<tr>
<th>Function:
<th>Language:
<th>Description:
<th>URL:
<th>File:

END_OF_HEADER

for (@ARGV) {
    $program = Program->new($_);
    $program->initialize_and_parse;
    $program->print_sub_descriptions(\&printr, $opt_u);
}

print <<END_OF_FOOTER;
</table>
</body>
</html>
END_OF_FOOTER

sub printr {
    my ($subname, $code, $desc, $comment, $filename, $language, $url) = @_;
    $comment = "$desc ($comment)" if $desc ne '';
    print <<FUNCTION_DESCRIPTION;
<tr>
<td>$subname
<td>$language
<td>$comment
<td>$url
<td>$filename

FUNCTION_DESCRIPTION
}
